* cr.prg
* compare two records side by side, with many bells and whistles
* Copyright Maurice L. Frank, 1989
* Foxbase 2.1 (also works in FoxPro)
* Version 1.00 12/28/89

* to report bugs or request enhancements (what? it doesn't do enough already!)
* leave me a message on the Atlanta Data Base Users Society BBS (404) 998-2804

* run cr with its parameters then press F1 to see options


parameters mdbf,mndx,mrecord1,mrecord2

set procedure to cr                                && more prgs in this file

*  parameters:
*
*  mdbf:       dbf name to be opened or currently used dbf if null
*  mndx:       index file to be activated; record number order if null
*  mrecord1:   a record # if if no index is opened, or a key if index is used
*  mrecord2:   same as above for second record (right side); if 0, mrecno1 + 1
*

clear

set talk off
set status off
set echo off
set bell off
?? sys(2002)

if len(ltrim(trim(mdbf))) > 0
   * open dbf if not null, otherwise assume its open and selected
   use &mdbf
endif
mdbf = dbf()                                       && includes path
if substr(mdbf,2,1) # ":"
   mdbf = sys(5) + mdbf                            && append drive
endif
mdbf = lower(mdbf)
mdbf_nm = right(mdbf,len(mdbf)-atlast("\",mdbf))   && strip off path for display

* if there is an index file to use open it, seek records, place recs in array
* else (no index), goto records *** needs error checking

if len(trim(mndx)) > 0
   set index to &mndx
   seek mrecord1
   scatter to array1
   seek mrecord2
   scatter to array2
   morder = "1"
else
   goto mrecord1
   scatter to array1
   * shortcut: if recno2 = 0, use next record after recno1
   mrecord2 = iif(mrecord2=0,min(reccount(),mrecord1+1),mrecord2)
   goto mrecord2
   scatter to array2
   morder = "0"
endif

mfcount = fldcount()

mseparator = "|"                 &&chr(179) - ascii stuff screws up printing

mdisp_ttl = .f.
mtitle = space(40)

mdisp_recn = .t.
mdisp_fnum = .t.
mdisp_fnam = .t.
mzoom = .f.

mlock_flds = 0
mtop_fld = 1 + mlock_flds

mwrap = .t.
mlock_left = .f.
mdisp_one = .f.

mdisp_comp = .t.

mdisp_help = .t.
mhelp_msg = "DBF: " + mdbf_nm + space(4) + ;
            chr(25) + " " + chr(24) + chr(26) + " " + chr(27) + " etc." + ;
            "        Options: TRLCFNHWZ1GSJDIB*         F1 Help"

mscrn_cols = 80
mscrn_rows = 24

mcol_wdth = (mscrn_cols - iif(mdisp_fnum,4,0) - iif(mdisp_fnam,10,0) - 2) / 2
mcol1 = 0 + iif(mdisp_fnum,4,0) + iif(mdisp_fnam,10,0)
mcol2 = mcol1 + mcol_wdth + 1

mlist_size = mscrn_rows - iif(mdisp_ttl,2,0) - iif(mdisp_help,2,0)
mtop_row = iif(mdisp_ttl,3,1)


mrefresh = .t.
mdisplay = .t.
do while mdisplay

   if mrefresh

      mrow = mtop_row
      @ mrow,00 to iif(mdisp_help,23,24),79 clear

      * display title if not blank; adjust top row, list size, next row variables

      if mdisp_ttl .and. len(trim(mtitle)) > 0
         @ 01,00 clear to 02,79
         @ 01,(mscrn_cols-len(ltrim(trim(mtitle))))/2 say ltrim(trim(mtitle))
      endif

      * display record number if used to access records for display

      if mdisp_recn

         if mdisp_fnam
            @ mrow,mcol1 - 10 say "Record #"
         endif

         if mdisp_fnum .or. mdisp_fnam
            @ mrow,mcol1 - 1 say mseparator
         endif

         @ mrow,mcol1 say mrecord1

         if .not. mdisp_one
            @ mrow,mcol2 - 1 say mseparator
            @ mrow,mcol2 say mrecord2
         endif

         mrow = mrow + 1

      endif

      * display fields to be locked at top of screen

      if mlock_flds > 0

         mcount_l = 1
         do while mcount_l <= mlock_flds

            do cr_line with mrow, mcount_l

            mcount_l = mcount_l + 1
            mrow = mrow+1

         enddo

         mcount = mcount_l

      endif

      if mdisp_help
         set color to n/w
         @ 24,00 clear

         @ 24,00 say mhelp_msg

         * @ 24,00 say "DBF: " + mdbf_nm
         * @ 24,21 say chr(25) + " " + chr(24) + chr(26) + " " + chr(27) + "etc."
         * @ 24,41 say "Options: TRLFNHWZ1GSJDIB*"
         * @ 24,73 say "F1 Help"
         set color to
      endif

      * display remaining field names and contents; mcount determines first field displayed


      mcount = mtop_fld
      do while mcount <= mfcount .and. mrow <= iif(mdisp_help,22,24)

         do cr_line with mrow, mcount

         mrow = mrow + 1
         mcount = mcount + 1

      enddo mcount < mfcount

      mrow = mrow - 1

      mrefresh = .f.

   endif mrefresh

   * wait for keystroke

   maction = inkey(0)

   * convert inkey value for uppercase to lower case

   maction = iif(maction>=97.and.maction<=122,maction-32,maction)

   * process cursor control/scrolling keystroke from user

   do case
      case maction = 24
         * down arrow
         if mcount < mfcount
            scroll mtop_row+iif(mdisp_recn,1,0)+mlock_flds,0,iif(mdisp_help,22,24),79,1
            do cr_line with iif(mdisp_help,22,24), mcount
            mcount = mcount + 1
            mtop_fld = min(mfcount,mtop_fld+1)
         endif
      case maction = 3 .or. maction = 13 .or. maction = 32
         * pgdn, enter, space bar
         mscrl_lines = mlist_size - mlock_flds - iif(mdisp_recn,1,0)
         mrefresh = mtop_fld # min(mfcount,mtop_fld+mscrl_lines)
         mtop_fld = min(mfcount,mtop_fld+mscrl_lines)
      case maction = 5
         * up arrow
         if mtop_fld > 1
            scroll mtop_row+iif(mdisp_recn,1,0),0,iif(mdisp_help,22,24),79,-1
            do cr_line with mtop_row+mlock_flds+iif(mdisp_recn,1,0), mtop_fld - 1
            mcount = mcount - 1
            mtop_fld = max(mlock_flds,mtop_fld-1)
         endif
      case maction = 18
         * pgup - must compute number fields to scroll
         mscrl_lines = mlist_size - mlock_flds - iif(mdisp_recn,1,0)
         mrefresh = mtop_fld # max(mlock_flds+1,mtop_fld-mscrl_lines)
         mtop_fld = max(mlock_flds+1,mtop_fld-mscrl_lines)
      case maction = 4 .or. maction = 9 .or. maction = 43
         * right, tab, or + (move forward one record)
         goto mrecord2
         skip
         if .not. eof()
            if .not. mlock_left
               mrecord1 = mrecord2
               goto mrecord1
               scatter to array1
            endif
            skip
            mrecord2=recno()
            scatter to array2
            mrefresh = .t.
            * mtop_fld not changed - a matter of opinion
         else
            save screen to cr
            @ 24,00
            ?? chr(7) + "End of file reached (press any key)."
            mwait = inkey(0)
            skip -1
            restore screen from cr
         endif
      case maction = 19 .or. maction = 45 .or. maction = 127
         * left arrow, minus/dash. shift-tab (move backward one record)
         goto mrecord1
         skip -1
         if .not. bof()
            mrecord2 = mrecord1
            goto mrecord2
            scatter to array2
            if .not. mlock_left
               skip -1
               mrecord1 = recno()
               scatter to array1
            endif
            mrefresh = .t.
            * mtop_fld not changed - a matter of opinion
         else
            @ 24,00
            ?? chr(7) + "Beginning of file reached (press any key)."
            ?? inkey(0)
            mrefresh = .t.
         endif
      case maction = 26 .or. maction = 29 .or. maction = 31
         * ctrl left, ctrl home, ctrl pgup - beginning of file
         go top
         mrecord1 = recno()
         scatter to array1
         skip
         mrecord2 = recno()
         scatter to array2
         mrefresh = .t.
         * mtop_fld ?
      case maction = 2 .or. maction = 23 .or. maction = 30
         * ctrl right, ctrl end, ctrl pgdn - end of file
         go bottom
         mrecord2 = recno()
         scatter to array2
         skip -1
         mrecord1 = recno()
         scatter to array1
         mrefresh = .t.
         * mtop_fld ?
      case maction = 1
         * home key
         * first field after skipping any fields to lock
         mrefresh = mtop_fld # mlock_flds + 1
         mtop_fld = mlock_flds + 1
      case maction = 6
         * end key
         * go to last field then back up for number of fields per screen
         mrefresh = mtop_fld # max(mfcount - mlist_size + mlock_flds + 2, 1)
         mtop_fld = max(mfcount - mlist_size + mlock_flds + 2, 1)
      case maction = 108 .or. maction = 76
         * l = set lock fields
         save screen to cr
         @ 24,00
         @ 24,00 say "# of fields to lock:" get mlock_flds picture "@Z 99"
         ?? sys(2002,1)
         read
         ?? sys(2002)
         restore screen from cr
         mrefresh = .t.
         mtop_fld = mlock_flds + 1
      case maction = 82
         * r - display recno toggle
         mdisp_recn = .not. mdisp_recn
         mrefresh = .t.
      case maction = 84
         * t - titles
         @ 24,00
         @ 24,00 say "Display title:" get mdisp_ttl picture "Y"
         @ 24,18 say "Text:" get mtitle picture "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
         ?? sys(2002,1)
         read
         ?? sys(2002)
         mlist_size = mscrn_rows - iif(mdisp_ttl,2,0) - iif(mdisp_help,2,0)
         mtop_row = iif(mdisp_ttl,3,1)
         mrefresh = .t.
      case maction = 72
         * h - help toggle
         mlist_size = mscrn_rows - iif(mdisp_ttl,2,0) - iif(mdisp_help,2,0)
         mdisp_help = .not. mdisp_help
         mrefresh = .t.
      case maction = 68
         * d - dbf
         save screen to cr
         mdbf = trim(mdbf) + replicate(" ",60-len(trim(mdbf)))
         @ 24,00
         @ 24,00 say "DBF:" get mdbf
         ?? sys(2002,1)
         read
         ?? sys(2002)
         if readkey() # 12 .and. readkey() # 268
            * escape not pressed
            *** need recno error checking here
            use &mdbf
            mdbf = dbf()                                       && includes path
            if substr(mdbf,2,1) # ":"
               mdbf = sys(5) + mdbf                            && append drive
            endif
            mdbf = lower(mdbf)
            mdbf_nm = right(mdbf,len(mdbf)-atlast("\",mdbf))   && strip off path for display
            mhelp_msg = stuff(mhelp_msg,6,12,mdbf_nm+space(12-len(mdbf_nm)))
            mndx = ""
            morder = "0"
            mcount = 1
            mtop_fld = 1
            mrecord1 = 1
            goto mrecord1
            release array1                         && leftover fields if not released
            scatter to array1
            mrecord2 = 2
            goto mrecord2
            release array2
            scatter to array2
            mfcount = fldcount()            && call udf to chk for memo flds
            mrefresh = .t.
         else
            * escape - no action
            restore screen from cr
         endif
      case maction = 73
         * i - index file  (NEED ERROR TRAPPING)
         save screen to cr
         mndx = trim(mndx) + replicate(" ",60-len(trim(mndx)))
         @ 24,00
         @ 24,00 say "Index:" get mndx
         @ 24,72 say "Order:" get morder picture "9"
         ?? sys(2002,1)
         read
         ?? sys(2002)
         if readkey() # 12 .and. readkey() # 268
            set index to &mndx
            set order to &morder
         endif
         restore screen from cr
      case maction = 70
         * f - field number toggle
         mdisp_fnum = .not. mdisp_fnum
         mcol_wdth = (mscrn_cols - iif(mdisp_fnum,4,0) - iif(mdisp_fnam,10,0) - 2) / 2
         mcol_wdth = iif(mdisp_one,(mcol_wdth*2)+1,mcol_wdth)
         mcol1 = 0 + iif(mdisp_fnum,4,0) + iif(mdisp_fnam,10,0)
         mcol2 = mcol1 + mcol_wdth + 1
         mrefresh = .t.
      case maction = 78
         * n - field name toggle
         mdisp_fnam = .not. mdisp_fnam
         mcol_wdth = (mscrn_cols - iif(mdisp_fnum,4,0) - iif(mdisp_fnam,10,0) - 2) / 2
         mcol_wdth = iif(mdisp_one,(mcol_wdth*2)+1,mcol_wdth)
         mcol1 = 0 + iif(mdisp_fnum,4,0) + iif(mdisp_fnam,10,0)
         mcol2 = mcol1 + mcol_wdth + 1
         mrefresh = .t.
      case maction = 49
         * 1 - single column
         if .not. mdisp_one
            * turn on
            mcol_wdth = (mcol_wdth*2) + 2
         else
            * turn off
            mcol_wdth = (mcol_wdth/2) - 2
         endif
         mdisp_one = .not. mdisp_one
         mrefresh = .t.
      case maction = 87
         * w - wrap long character fields
         mwrap = .not. mwrap
         @ 24,00
         ?? "Wrap turned " + iif(mwrap,"on.","off.")
         mwait = inkey(3)
         mrefresh = .t.
      case maction = 46
         * . (period) - lock left column
         mlock_left = .not. mlock_left
         save screen to cr
         @ 24,00
         ?? "Left column " + iif(mlock_left,"locked.","unlocked.")
         mwait = inkey(5)
         restore screen from cr
      case maction = 71
         * g - goto
         mrecno1 = 0
         mrecno2 = 0
         @ 24,00
         @ 24,00 say "Goto Record #"
         @ 24,mcol1 get mrecno1 picture "@Z 999999"
         @ 24,mcol2 get mrecno2 picture "@Z 999999"
         ?? sys(2002,1)
         read
         ?? sys(2002)
         if mrecno1 > 0 .and. mrecno1 <= reccount()
            goto mrecno1
            mrecord1 = mrecno1
            scatter to array1
         endif
         if mrecno2 > 0 .and. mrecno2 <= reccount()
            goto mrecno2
            mrecord2 = mrecno2
            scatter to array2
         endif
         mrefresh = .t.       && help line
      case maction = 73
         * j - jump
         mjump1 = 0
         mjump2 = 0
         @ 24,00
         @ 24,00 say "# Records +/-"
         @ 24,mcol1 get mjump1 picture "@Z 999999"
         @ 24,mcol2 get mjump2 picture "@Z 999999"
         ?? sys(2002,1)
         read
         ?? sys(2002)
         if mjump1 # 0
            goto mrecord1
            skip mjump1
            skip iif(eof(),-1,0)
            mrecord1 = recno()
            scatter to array1
         endif
         if mjump2 # 0
            goto mrecord2
            skip mjump2
            skip iif(eof(),-1,0)
            mrecord2 = recno()
            scatter to array2
         endif
         mrefresh = .t.
      case maction = 83
         * s - seek
         if len(ltrim(trim(mndx))) > 0 .and. morder > "0"
            mseek1 = space(mcol_wdth)
            mseek2 = space(mcol_wdth)
            @ 24,00
            @ 24,00 say "Seek:"
            @ 24,mcol1 get mseek1
            @ 24,mcol2 get mseek2
            ?? sys(2002,1)
            read
            ?? sys(2002)
            if len(ltrim(trim(mseek1))) > 0
               seek trim(mseek1)
               if found()
                  mrecord1 = recno()
                  scatter to array1
                  mrefresh = .t.
               else
                  @ 24,mcol say space(mcol_wdth)
                  @ 24,mcol say " *** not found ! ***"
               endif
            endif
            if len(ltrim(trim(mseek2))) > 0
               seek trim(mseek2)
               if found()
                  mrecord2 = recno()
                  scatter to array2
                  mrefresh = .t.
               else
                  @ 24,mcol + mcol_wdth + 2 say space(mcol_wdth)
                  @ 24,mcol + mcol_wdth + 2 say " *** not found ! ***"
               endif
            endif
         else
            save screen to cr
            @ 24,00
            ?? chr(07) + "Cannot seek - no active index!  (press any key)"
            mwait = inkey(0)
            restore screen from cr
         endif
      case maction = 66
         * b - browse nomodify
         save screen to cr
         goto mrecord1
         browse nomodify
         goto mrecord2
         restore screen from cr
      case maction = 67
         * c - compare fields
         mdisp_comp = .not. mdisp_comp
         @ 24,00
         ?? "Compare fields turned " + iif(mdisp_comp,"on.","off.")
         mwait = inkey(3)
         mrefresh = .t.
      case maction = 80
         * p - print
         do cr_print
      case maction = 42
         * asterisk - display structure
         save screen to cr
         clear
         display structure
         mwait = inkey(0)
         restore screen from cr
      case maction = 28
         * f1 - help
         do cr_help
      case maction = 27 .or. maction = 81
         * escape key, q, Q (quit)
         mdisplay = .f.
      case maction = 90
         * z - zoom
         mzoom = .not. mzoom
         mdisp_ttl = .not. mzoom
         mdisp_help = .not. mzoom
         mdisp_fnum = .not. mzoom
         mdisp_fnam = .not. mzoom
         mwrap = .not. mzoom
         * use same formulas - could be simplified
         mtop_row = iif(mdisp_ttl.and.len(trim(mtitle))>0,3,1)
         mlist_size = mscrn_rows - iif(mdisp_ttl,2,0) - iif(mdisp_help,2,0)
         mcol_wdth = (mscrn_cols - iif(mdisp_fnum,4,0) - iif(mdisp_fnam,10,0) - 2) / 2
         mcol_wdth = iif(mdisp_one,(mcol_wdth*2)+1,mcol_wdth)
         mcol1 = 0 + iif(mdisp_fnum,4,0) + iif(mdisp_fnam,10,0)
         mcol2 = mcol1 + mcol_wdth + 1
         mrefresh = .t.
      case maction = 88
         * x - for debugging
         save screen to cr
         susp
         rest screen from cr
      otherwise
         save screen to cr
         @ 24,00
         ?? "No function for that key." + chr(7)
         ?? inkey(5)
         restore screen from cr
   endcase

enddo while mdisplay

if len(ltrim(trim(mdbf))) > 0
   * if it was opened by program, close it, else, leave it open
   use
endif

clear
?? sys(2002,1)

return


*********
procedure fldcount
*********

private i, j

i = 1
do while type("array1(i)") # "U"
   i = i + 1
enddo
i = i - 1

if i < fcount()
   * number of array elements is less than field count - probably memo fields
   j = fcount() - i
   @ 24,00
   ?? ltrim(str(j))
   if j = 1
      ?? " field is not shown."
   else
      ?? " fields are not shown."
   endif
   mwait = inkey(5)
   @ 24,00
endif

return i



*********
procedure cr_line
*********

* display line incl field num, field name, field1, field2, separators

parameters mrow, mcount

if mdisp_fnum
   @ mrow,0 say mcount picture "999"
endif

if mdisp_fnam
   @ mrow,mcol1 - 10 say field(mcount)
endif

if mdisp_fnum .or. mdisp_fnam
   @ mrow,mcol1 - 1 say mseparator
endif

if .not. mdisp_one
   if mdisp_comp
      mcomp = compfld(array1(mcount),array2(mcount))
      set color to w+/n
      @ mrow,mcol2 - 1 say mcomp
      set color to
   else
      @ mrow,mcol2 - 1 say mseparator
   endif
endif

* display field data

do case
   case type(field(mcount))="C"
      if len(array1(mcount)) <= mcol_wdth
         @ mrow,mcol1 say array1(mcount)
         if .not. mdisp_one
            @ mrow,mcol2 say array2(mcount)
         endif
      else
         if mwrap
            mwrap_len = max( len(trim(array1(mcount))) ,len(trim(array2(mcount))) )
            * if mwrap_len > mcol_wdth
               mwrap_row = (mwrap_len/mcol_wdth)
               * round up
               mwrap_row = mwrap_row + iif( mod(mwrap_len/mcol_wdth,1)=0 , 0 , 1-mod(mwrap_len/mcol_wdth,1) )
               mwrap_cnt = 1
               do while mwrap_cnt <= mwrap_row
                  moffset = ((mwrap_cnt-1)*mcol_wdth) + 1
                  mlen = min(len(array1(mcount))-moffset+1,mcol_wdth)
                  if mcol1 > 1
                     @ mrow,mcol1 - 1 say mseparator
                  endif
                  @ mrow,mcol1 say substr(array1(mcount),moffset,mlen)
                  if .not. mdisp_one
                     @ mrow,mcol2 - 1 say mseparator
                     @ mrow,mcol2 say substr(array2(mcount),moffset,mlen)
                  endif
                  mrow = iif(mwrap_cnt < mwrap_row, mrow + 1, mrow)
                  mwrap_cnt = mwrap_cnt + 1
               enddo
            * else
            *    @ mrow,mcol1 say left(array1(mcount),mcol_wdth)
            *    @ mrow,mcol2 say left(array2(mcount),mcol_wdth)
            * endif
         else
            * truncate
            @ mrow,mcol1 say left(array1(mcount),mcol_wdth)
            if .not. mdisp_one
               @ mrow,mcol2 say left(array2(mcount),mcol_wdth)
            endif
         endif
      endif
   case type(field(mcount))="L"
      @ mrow,mcol1 say array1(mcount) picture "Y"
      if .not. mdisp_one
         @ mrow,mcol2 say array2(mcount) picture "Y"
      endif
   otherwise
      * numeric and date
      @ mrow,mcol1 say array1(mcount)
      if .not. mdisp_one
         @ mrow,mcol2 say array2(mcount)
      endif
endcase

return


*********
procedure cr_help
*********

save screen to cr
clear
text
                                Compare Records

Dbf:                                      Fields:            
Idx:                                      Records:
Key:                                      Updated:

FIELD DISPLAY                             RECORD NAVIGATION
  Enter Space    : scroll one field         +    -       : next record
PgDn, PgUp       : scroll screen full     Tab, Backspace : previous record
Home, End        : top, bottom            Ctrl-Left, Ctrl-Right : first, last
                                          G   Goto (record #)
OPTIONS & TOGGLES                         S   Seek (indexed search)
T   Screen title                          J   Jump (# records forward/backward)
R   Record number display     
L   Lock records at top                   
C   Compare fields                        MISCELLANEOUS
F   Field number display                  Escape, Q   Quit Program   
N   Field name display                    B           Browse Nomodify
W   Wrap long character fields            *           Display Structure
1   Display one column                    P           Print
.   Lock left record
H   Help display      

Press any key to exit help.           (Maurice L. Frank  Version 1.00 12/28/89)
endtext

set color to w+/n
@ 01,32 say "Compare Records"
@ 07,00 say "FIELD DISPLAY"
@ 07,42 say "RECORD NAVIGATION"
@ 12,00 say "OPTIONS & TOGGLES"
@ 16,42 say "MISCELLANEOUS"
@ 24,00 say "Press any key to exit help."
set color to

@ 03,05 say mdbf
@ 04,05 say mndx
@ 05,05 say iif(morder="0","record number",lower(sys(14,val(morder))))
@ 03,67 say fcount() picture "999"
@ 04,60 say reccount() picture "99,999,999"
@ 05,62 say lupdate()

@ 08,00 say chr(25)                                && down arrow
@ 08,15 say chr(24)                                && up arrow
@ 08,42 say chr(26)                                && right arrow
@ 08,47 say chr(27)                                && left arrow

@ 13,17 say "(" + iif(len(trim(mtitle))>0,trim(mtitle),"NONE") + ")" ;
            + "  (" + iif(mdisp_ttl,"ON","OFF") + ")"
@ 14,26 say "(" + iif(mdisp_recn,"ON","OFF") + ")"
@ 15,24 say "(" + iif(mlock_flds=0,"NONE",mlock_flds) + ")"
@ 16,19 say "(" + iif(mdisp_comp,"ON","OFF") + ")"
@ 17,25 say "(" + iif(mdisp_fnum,"ON","OFF") + ")"
@ 18,23 say "(" + iif(mdisp_fnam,"ON","OFF") + ")"
@ 19,31 say "(" + iif(mwrap,"ON","OFF") + ")"
@ 20,23 say "(" + iif(mdisp_one,"ON","OFF") + ")"
@ 21,21 say "(" + iif(mlock_left,"ON","OFF") + ")"
@ 22,17 say "(" + iif(mdisp_help,"ON","OFF") + ")"

mwait = inkey(0)
restore screen from cr

return



*********
procedure atlast
*********

* find last occurrence of a character in a string

parameters mchr, mstring

private mchr, mstring, mposition, mchrlen, mstrlen

mposition = 0
mchrlen = len(mchr)
mstrlen = len(trim(mstring))
do while mstrlen > 0
   if substr(mstring,mstrlen,mchrlen) = mchr
      mposition = mstrlen
      exit
   endif
   mstrlen = mstrlen - 1
enddo

return mposition


*********
procedure cr_print
*********

save screen to cr

set color to w/n
@ 24,00
@ 24,34 say "* printing *"
set color to

set console off
set device to print

mcr_lf = chr(13) + chr(10)

* assume one page for now

if mdisp_ttl .and. len(trim(mtitle)) > 0
   @ prow(),(mscrn_cols-len(ltrim(trim(mtitle))))/2 say ltrim(trim(mtitle))
   @ prow(),pcol() say mcr_lf + mcr_lf
endif

if mdisp_recn
   if mdisp_fnam
      @ prow(),mcol1 - 10 say "Record #"
   endif
   if mdisp_fnum .or. mdisp_fnam
      @ prow(),mcol1 - 1 say mseparator
   endif
   @ prow(),mcol1 say mrecord1
   if .not. mdisp_one
      @ prow(),mcol2 - 1 say mseparator
      @ prow(),mcol2 say mrecord2
   endif
   @ prow(),pcol() say mcr_lf
endif

* if mlock_flds > 0
*    mcount_l = 1
*    do while mcount_l <= mlock_flds
*       do cr_line with prow(), mcount_l
*       mcount_l = mcount_l + 1
*       @ prow(),pcol() say mcr_lf
*    enddo
*    mcount = mcount_l
* else
*    mcount = 1
* endif

* print remaining fields

mcount = 1
do while mcount <= mfcount
   do cr_line with prow(), mcount
   @ prow(),pcol() say mcr_lf
   mcount = mcount + 1
enddo mcount < mfcount
eject

set device to screen
set console on
restore screen from cr

return
******


*********
procedure compfld
*********
* compare fields
* returns operator (or m for memo fields) comparing two values
* Maurice Frank

parameters mval1, mval2

private mval1, mval2, mcomp

do case
   case type("mval1") $ "CDN"
      do case
         case mval1 > mval2
            mcomp = ">"
         case mval1 < mval2
            mcomp = "<"
         case mval1 = mval2
            mcomp = "="
      endcase
   case type("mval1") = "L"
      mcomp = iif((mval1.and.mval2).or.(.not.mval1.and..not.mval2),"=","#")
   case type("mval1") = "M"
      mcomp = "M"
   otherwise
      * new field types or miscellaneous error
      mcomp = "?"
endcase

return mcomp

